<?php

/**
 * factura_portal_abaco actions.
 * 
 * http://10.0.100.218/cartera/web/api_dev.php/api/factura_portal_abaco/add.json?num_doc=0011112&id_tipo_doc=1&id_nat_jur=22&id_tip_ter=1&razon_soc=&direccion=CALLE&coddepto=25&ciudad=BOG&email=facweb@sof&id_punto_venta=102&valor_bruto=100&valor_iva=16&valor_total=100&id_producto=1740&cantidad=1&valor_uni_bruto=100&valor_uni_iva=16&valor_uni_total=100&id_ts_pc_fp=12&valor=100&id_bn=11&id_cb=36&num_doc_sop=123465687912&fecha_doc_sop=2014-12-24&pnombre_snombre_papellido_sapellido=Mario--Jerez-Quintero
 *
 * @package    cartera
 * @subpackage factura_portal_abaco
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class factura_portal_abacoActions extends sfActions {

    /**
     * Incidente #10372, Facturación electrónica - 20181114
     * 
     * Validacion de campo numerico campos valor is_numeric - 20200120
     *
     * @param sfRequest $request A request object
     */
    public function executeAdd(sfWebRequest $request) {

        //Log especifico de procesos completos - 20160527
        $logPath = sfConfig::get('sf_log_dir') . '/factura_portal_abaco.log';
        $this->custom_logger = new sfFileLogger(new sfEventDispatcher(), array('file' => $logPath));

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->custom_logger->info("---BEGIN Logging request");
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
            $this->custom_logger->info("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        $this->custom_logger->info("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
            $this->custom_logger->info("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");
        $this->custom_logger->info("---END Logging request");


        /**
         * Abrir nueva conexion con la Base de Datos
         */
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        $id_log_factura = 0;
        $time_log = time();

        //Variables por defecto para el registro de log - 20160527
        $id_tabla = 'null';
        $id_vigencia = 'null';
        $id_cen_op = 'null';
        $id_cia = 'null';

        //obtener id maestro tabla
        $id_mae_bd = CN_TABLE::consultarIdTablaBD('CA_FACTURA_POS');

        //  1- CONSULTAR, 2- ACTUALIZAR, 3 - ADICIONAR, 4 - ELIMINAR, 5 - ANULAR
        $id_ope_bd = 3;
        //id del maestro tercero
        $id_mae_ter_log = 1;
        $usuario = 'admin';
        $comando = 'factura_portal_abaco';
        //construir observacion
        $observacion = "'Se ingreso a generar factura desde servicio web factura portal abaco'";

        $id_punto_venta = '102';

        //Manejo de errores
        //Variables obligatorias
        $id_anhos = date('Y');
        $fecha_proceso = CN_TABLE::fechaSistema();

        //sentencia sql
        $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;

        //ejecuta el sql
        CN_TABLE::executeSQL($sql);

        //variable para los errores
        $error = false;
        $errorVar = "";
        $email = "";

        /*
         * variables
         */
        //obtiene el valor para su identificador unico
        $id_tabla = 'null';
        if (isset($request['id_tabla'])) {
            $id_tabla = $request['id_tabla'];
        } else {
            $id_tabla = $time_log;
        }

        /**
         * Validar errores de procedimiento
         */
        try {
            // Registro de consulta en tabla de log
            $this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $observacion . ".\n");
            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

            //Datos obligactorios del servicio - num_doc,valor_total,id_producto,cantidad,id_ts_pc_fp,num_doc_sop,fecha_doc_sop - 20160527
            if (isset($request['num_doc']) && isset($request['valor_total']) && isset($request['id_producto']) && isset($request['cantidad']) && isset($request['id_ts_pc_fp']) && isset($request['num_doc_sop']) && isset($request['fecha_doc_sop'])) {
                //Inicializacion de parametros de entrada
                $this->num_doc = $request['num_doc'];
                $this->valor_total = $request['valor_total'];
                $this->id_producto = $request['id_producto'];
                $this->cantidad = $request['cantidad'];
                $this->id_ts_pc_fp = $request['id_ts_pc_fp'];
                $this->num_doc_sop = $request['num_doc_sop'];
                $this->fecha_doc_sop = $request['fecha_doc_sop'];

                $this->parameters = true;
            } else {
                $this->parameters = false;
                throw new Exception("Falta alguno de los parámetros obligatorios (num_doc,valor_total,id_producto,cantidad,id_ts_pc_fp,num_doc_sop,fecha_doc_sop)");
            }

            $resultado = array();


            //num_doc - tercero
            $num_doc = 'null';
            if (isset($request['num_doc'])) {
                $num_doc = $request['num_doc'];
            } else {
                $error = true;
                $errorVar .= "-num_doc";
            }
            $email = 'null';
            if (isset($request['email'])) {
                $email = $request['email'];
            } else {
                $error = true;
                $errorVar .= "-email";
            }

            $razon_soc = '';
            if (isset($request['razon_soc'])) {
                $razon_soc = str_replace('-', ' ', utf8_encode($request['razon_soc']));
            } else {
                $error = true;
                $errorVar .= "-razon_soc";
            }


            /*
             * Verificar tercero por num_doc, sino lo crea
             */
            //sentencia sql
            $sql = <<<EOD
select * from interceros where num_doc = '$num_doc'   
EOD;
            //ejecuta el sql
            //$this->conn->execute($sql);
            $resultado_ter = CN_TABLE::executeSQL($sql);

            /**
             * Crear tercero
             */
            if (count($resultado_ter) <= 0) {

                /*
                 * TERCERO :: 
                  ID_NAT_JUR
                  ID_TIP_TER
                  ID_TIPO_DOC
                  NUM_DOC
                  PNOMBRE-SNOMBRE-PAPELLIDO-SAPELLIDO
                  RAZON_SOC
                  DIRECCION
                  CIUDAD
                  TELEFONO
                  EMAIL
                  CODDEPTO
                 */
                $id_nat_jur = 'null';
                if (isset($request['id_nat_jur'])) {
                    $id_nat_jur = $request['id_nat_jur'];
                } else {
                    $error = true;
                    $errorVar .= "id_nat_jur";
                }
                $id_tip_ter = 'null';
                if (isset($request['id_tip_ter'])) {
                    $id_tip_ter = $request['id_tip_ter'];
                } else {
                    $error = true;
                    $errorVar .= "-id_tip_ter";
                }
                $id_tipo_doc = 'null';
                if (isset($request['id_tipo_doc'])) {
                    $id_tipo_doc = $request['id_tipo_doc'];
                } else {
                    $error = true;
                    $errorVar .= "-id_tipo_doc";
                }

                /**
                 * PNOMBRE-SNOMBRE-PAPELLIDO-SAPELLIDO=Mario-Andres-Jerez-Quintero
                 */
                $pnombre = '';
                $snombre = '';
                $papellido = '';
                $sapellido = '';
                $pnombre_snombre_papellido_sapellido = '';
                if (isset($request['pnombre_snombre_papellido_sapellido'])) {
                    $pnombre_snombre_papellido_sapellido = $request['pnombre_snombre_papellido_sapellido'];

                    $variables = explode('-', $pnombre_snombre_papellido_sapellido);

                    $pnombre = $variables[0];
                    $snombre = $variables[1];
                    $papellido = $variables[2];
                    $sapellido = $variables[3];
//                } else {
//                    $error = true;
//                    $errorVar .= "-pnombre_snombre_papellido_sapellido";
                }
                //$error = true;
                //$errorVar .= $pnombre . "::" . $snombre . "::" . $papellido . "::" . $sapellido;

                /*
                  $pnombre = '';
                  if (isset($request['pnombre'])) {
                  $pnombre = $request['pnombre'];
                  } else {
                  $error = true;
                  $errorVar .= "-pnombre";
                  }
                  $snombre = '';
                  if (isset($request['snombre'])) {
                  $snombre = $request['snombre'];
                  }
                  $papellido = '';
                  if (isset($request['papellido'])) {
                  $papellido = $request['papellido'];
                  } else {
                  $error = true;
                  $errorVar .= "-papellido";
                  }
                  $sapellido = '';
                  if (isset($request['sapellido'])) {
                  $sapellido = $request['sapellido'];
                  } else {
                  $error = true;
                  $errorVar .= "-sapellido";
                  }
                 */
                $direccion = '';
                if (isset($request['direccion'])) {
                    $direccion = utf8_decode($request['direccion']);
                    $direccion = str_replace("'", " ", $direccion); //Quitar comilla simple - 20180713
                    $this->logMessage("Direccion::" . $direccion);
                } else {
//                    $error = true;
//                    $errorVar .= "-direccion";
                }
                $ciudad = 'Bogota';
                //Se coloca validacion $request['ciudad'] != '', por si viene vacia - 20160803
                if (isset($request['ciudad']) && $request['ciudad'] != '') {
                    $ciudad = utf8_decode($request['ciudad']);
                } else {
//                    $error = true;
//                    $errorVar .= "-ciudad";
                }
                $telefono = '';
                if (isset($request['telefono'])) {
                    $telefono = $request['telefono'];
                }
                $coddepto = '';
                if (isset($request['coddepto'])) {
                    $coddepto = $request['coddepto'];
                } else {
//                    $error = true;
//                    $errorVar .= "-coddepto";
                }

                $id_mae_ter = 0;
                if ($error) {
                    /*
                     * Mensaje de error
                     */
                    $mensajeError = "TER :: Los datos de entrada estan incorrectos." . " Variables :: " . $errorVar;

                    $this->status = 1;
                    $this->list_data = array();
                    $this->mensajeError = $mensajeError;
                    $this->logMessage("[FACTURA_PORTAL_ABACO] TER :: " . $mensajeError);
                    $this->custom_logger->info("[FACTURA_PORTAL_ABACO] TER :: " . $mensajeError);

                    /*
                     * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
                     */
                    $id_ope_bd = 3;
                    $observacion = "'Se termino el proceso de factura_portal_abaco, se generaron errores en el proceso de creación.'";
                    $this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $observacion . ".\n");



                    /**
                     * Abrir nueva conexion con la Base de Datos
                     */
//                    $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
//                    $this->conn->beginTransaction();
                    CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

                    $error_log = $mensajeError . ". Correo de envio: " . $email;

                    if ($this->parameters) {

                        $sql = <<<EOD
Insert into CA_LOG_FACTURA_ERRORES (ID_LOG_FACTURA_ERRORES,NUM_DOC,VALOR_TOTAL,ID_PRODUCTO,
    CANTIDAD,ID_TS_PC_FP,NUM_DOC_SOP,FECHA_DOC_SOP,
        FECHA_LOG,USUARIO_LOG,MOTIVO_ERROR) 
values (null,'$this->num_doc','$this->valor_total','$this->id_producto',
    '$this->cantidad','$this->id_ts_pc_fp','$this->num_doc_sop',to_date('$this->fecha_doc_sop', 'yyyy-mm-dd'),
        sysdate,'websafi','$error_log') 
EOD;

                        $records = CN_TABLE::executeSQL($sql, true);
                    }

//                    $this->conn->commit();
                } else {
                    $this->logMessage("Crear tercero");
                    $this->custom_logger->info("[FACTURA_PORTAL_ABACO] Crear tercero");

                    //verificar persona para el digito de verificacion}
                    $dv = 'null';
                    if ($num_doc >= 800000000 && $num_doc <= 999999999) {
                        //sentencia sql
                        $sql = <<<EOD
select digito_verificacion($num_doc) as dv from dual 
EOD;
                        //ejecuta el sql
                        //$this->conn->execute($sql);
                        $resultado = CN_TABLE::executeSQL($sql);
                        $dv = $resultado[0]['dv'];
                    }

                    /**
                     * Crear registros de tercero tabla INTERCEROS - INTERCEROS_DU - INTERCEROS_DU_DIR
                     */
                    //sentencia sql
                    $sql = <<<EOD
Insert into INTERCEROS (ID_MAE_TER,ID_NAT_JUR,ID_TIP_TER,ID_TIPO_DOC,NUM_DOC,CODIGO,
    RAZON_SOC,CAM_COM,PNOMBRE,SNOMBRE,ESTADO_TER,FECHA_DOC,PAPELLIDO,SAPELLIDO,
        NMATRICULA,NMATRICULAMER,PROFESION,DV,OBJETIVO) 
    values (null,$id_nat_jur,$id_tip_ter,$id_tipo_doc,'$num_doc',null,
        upper('$razon_soc'),null,upper('$pnombre'),upper('$snombre'),1,null,upper('$papellido'),upper('$sapellido'),
            null,null,null,$dv,null)  
EOD;
                    //ejecuta el sql
                    $this->conn->execute($sql);

                    //sentencia sql
                    $sql = <<<EOD
select * from interceros where num_doc = '$num_doc'   
EOD;
                    //ejecuta el sql
                    //$this->conn->execute($sql);
                    $resultado_ter = CN_TABLE::executeSQL($sql);
                    if (count($resultado_ter) > 0) {
                        $id_mae_ter = $resultado_ter[0]['id_mae_ter'];
                    } else {
                        $id_mae_ter = 0;
                    }

                    //sentencia sql                
                    $sql = <<<EOD
Insert into INTERCER_DU (ID_MT_UBI,ID_MAE_TER,ID_LOC_DIR,WEB_SITE,MAIL,CONTACTO,
    CARGO_CON,AP_AEREO,MAIL_CON,ID_PAIS,COPDEPTO,CIUDAD) 
    values (null,$id_mae_ter,1,null,'$email',upper('$pnombre $papellido $sapellido'),
        null,null,'$email',49,'$coddepto',upper('$ciudad'))  
EOD;
                    //ejecuta el sql
                    $this->conn->execute($sql);


                    //sentencia sql
                    $sql = <<<EOD
select * from INTERCER_DU where id_mae_ter = $id_mae_ter   
EOD;
                    //ejecuta el sql
                    //$this->conn->execute($sql);
                    $resultado_ter = CN_TABLE::executeSQL($sql);
                    if (count($resultado_ter) > 0) {
                        $id_mt_ubi = $resultado_ter[0]['id_mt_ubi'];
                    } else {
                        $id_mt_ubi = 0;
                    }

                    //sentencia sql                
                    $sql = <<<EOD
Insert into INTERCER_DU_DIR (ID_UBI_DIR,ID_MT_UBI,ID_TIP_DIR,DIRECCION,TEL,FAX,ID_PAIS,CODDEPTO,CIUDAD,ESTADO,PRINCIPAL,CIUDAD_DANE,DEPTO_DANE) 
    values (null,$id_mt_ubi,1,'$direccion','$telefono',null,49,'$coddepto',upper('$ciudad'),1,1,null,null) 
EOD;
                    //ejecuta el sql
                    $this->conn->execute($sql);

                    $this->logMessage("Se creo el tercero");
                    $this->custom_logger->info("Se creo el tercero");
                }
            } else {
                $id_mae_ter = $resultado_ter[0]['id_mae_ter'];

                /**
                 * Actualizar datos(telefono,direcion,ciudad) del tercero - 20150318
                 */
                $direccion = '';
                if (isset($request['direccion']) && $request['direccion'] != '') {
                    $direccion = utf8_decode($request['direccion']);
                    $direccion = str_replace("'", " ", $direccion); //Quitar comilla simple - 20180713
                    $this->logMessage("Direccion::" . $direccion);
                } else {
//                    $error = true;
//                    $errorVar .= "-direccion";
                }
                $ciudad = 'Bogota';
                //Se coloca validacion $request['ciudad'] != '', por si viene vacia - 20160803
                if (isset($request['ciudad']) && $request['ciudad'] != '') {
                    $ciudad = utf8_decode($request['ciudad']);
                } else {
//                    $error = true;
//                    $errorVar .= "-ciudad";
                }
                $telefono = '';
                if (isset($request['telefono']) && $request['telefono'] != '') {
                    $telefono = $request['telefono'];
                }
                $coddepto = '';
                if (isset($request['coddepto']) && $request['coddepto'] != '') {
                    $coddepto = $request['coddepto'];
                } else {
//                    $error = true;
//                    $errorVar .= "-coddepto";
                }

                //sentencia sql
                $sql = <<<EOD
SELECT * FROM INTERCER_DU where ID_MAE_TER = $id_mae_ter  
EOD;
                //ejecuta el sql
                $resultado_terdu = CN_TABLE::executeSQL($sql);

                //Valida si es crear o actualizar tabla - 20160628
                if (count($resultado_terdu) == 0) {

                    $sql = <<<EOD
Insert into INTERCER_DU (ID_MT_UBI,ID_MAE_TER,ID_LOC_DIR,WEB_SITE,MAIL,CONTACTO,CARGO_CON,AP_AEREO,MAIL_CON,ID_PAIS,COPDEPTO,CIUDAD) 
values (null,'$id_mae_ter','1',null,'$email',null,null,null,null,'49','$coddepto',upper('$ciudad')) 
EOD;

                    //ejecuta el sql
                    CN_TABLE::executeSQL($sql);
                } else {

                    $id_mt_ubi = $resultado_terdu[0]['id_mt_ubi'];

                    //sentencia sql                
                    $sql = <<<EOD
update INTERCER_DU set ciudad = nvl('$ciudad',ciudad), COPDEPTO = '$coddepto'                   
where id_mt_ubi = $id_mt_ubi 
EOD;
                    //ejecuta el sql
                    $this->conn->execute($sql);
                }

                //sentencia sql
                $sql = <<<EOD
SELECT * FROM INTERCER_DU where ID_MAE_TER = $id_mae_ter  
EOD;
                //ejecuta el sql
                $resultado_terdu = CN_TABLE::executeSQL($sql);

                $id_mt_ubi = $resultado_terdu[0]['id_mt_ubi'];

                //sentencia sql
                $sql = <<<EOD
SELECT * FROM INTERCER_DU_DIR where ID_MT_UBI = $id_mt_ubi 
EOD;
                //ejecuta el sql
                $resultado_terdudir = CN_TABLE::executeSQL($sql);


                if (count($resultado_terdudir) > 0) {

                    $id_ubi_dir = $resultado_terdudir[0]['id_ubi_dir'];

                    //sentencia sql                
                    $sql = <<<EOD
update INTERCER_DU_DIR set  direccion = nvl('$direccion',direccion) , tel = nvl('$telefono',tel) , 
    ciudad = nvl('$ciudad',ciudad), CODDEPTO = '$coddepto'  
where ID_UBI_DIR = $id_ubi_dir 
EOD;
                    //ejecuta el sql
                    $this->conn->execute($sql);
                } else {
                    //sentencia sql                
                    $sql = <<<EOD
Insert into INTERCER_DU_DIR (ID_UBI_DIR,ID_MT_UBI,ID_TIP_DIR,DIRECCION,TEL,FAX,ID_PAIS,CODDEPTO,CIUDAD,ESTADO,PRINCIPAL,CIUDAD_DANE,DEPTO_DANE) 
    values (null,$id_mt_ubi,1,'$direccion','$telefono',null,49,'$coddepto',upper('$ciudad'),1,1,null,null) 
EOD;
                    //ejecuta el sql
                    $this->conn->execute($sql);
                }

                /*
                 * Se actualiza segun razon social de entrada - 20200402::LAVILA
                 */
                //sentencia sql                
                $sql = <<<EOD
update interceros 
set RAZON_SOC = nvl(upper('$razon_soc'),RAZON_SOC)
where
id_mae_ter = $id_mae_ter
EOD;
                //ejecuta el sql
                $this->conn->execute($sql);
            }

            //Se valida para que actualice campo de pnombre y papellido, segun fecha de razon soc si no tiene nombre - 20181121
            //sentencia sql                
            $sql = <<<EOD
update interceros 
set pnombre = substr(razon_soc, 1, instr(razon_soc, ' ') - 1),
    papellido = substr(razon_soc, instr(razon_soc, ' ') + 1)
where
id_mae_ter = $id_mae_ter
and (pnombre is null or papellido is null) 
EOD;
            //ejecuta el sql
            $this->conn->execute($sql);

            //verificar persona para el digito de verificacion} - 20191223
            //sentencia sql                
            $sql = <<<EOD
update interceros 
set dv = digito_verificacion('$num_doc')
where
id_mae_ter = $id_mae_ter
and dv is null 
EOD;
            //ejecuta el sql
            $this->conn->execute($sql);

            $this->logMessage("id_mae_ter :: " . $id_mae_ter);
            $this->custom_logger->info("id_mae_ter :: " . $id_mae_ter);


            /*
             * CA_FACTURA_POS
              ID_PUNTO_VENTA
              ID_CAJA
              SEC_FACTURA
              ID_MAE_TER
              FECHA_FACTURACION
              VALOR_BRUTO
              VALOR_IVA
              VALOR_TOTAL
              CAJERO
              OBSERVACIONES
             */
            if (isset($request['id_punto_venta'])) {
                $id_punto_venta = $request['id_punto_venta'];
            } else {
                $error = true;
                $errorVar .= "-id_punto_venta";
            }
            $valor_bruto = 'null';
            if (isset($request['valor_bruto']) && is_numeric($request['valor_bruto'])) {
                $valor_bruto = $request['valor_bruto'];
            } else {
                $error = true;
                $errorVar .= "-valor_bruto";
            }
            $valor_iva = 'null';
            if (isset($request['valor_iva']) && is_numeric($request['valor_iva'])) {
                $valor_iva = $request['valor_iva'];
            } else {
                $error = true;
                $errorVar .= "-valor_iva";
            }
            $valor_total = 'null';
            if (isset($request['valor_total']) && is_numeric($request['valor_total'])) {
                $valor_total = $request['valor_total'];
            } else {
                $error = true;
                $errorVar .= "-valor_total";
            }
            $observaciones = 'VENTAS PORTAL WEB';
            if (isset($request['observaciones'])) {
                $observaciones = $request['observaciones'];
            }


            /*
             * CA_FACTURA_PROD
              ID_PRODUCTO
              CANTIDAD
              VALOR_UNI_BRUTO
              VALOR_UNI_IVA
              VALOR_UNI_TOTAL
              REFERENCIA
             */
            $id_producto = '0';
            if (isset($request['id_producto'])) {
                $id_producto = $request['id_producto'];
            } else {
                $error = true;
                $errorVar .= "-id_producto";
            }
            $cantidad = '1';
            if (isset($request['cantidad'])) {
                $cantidad = $request['cantidad'];
            } else {
                $error = true;
                $errorVar .= "-cantidad";
            }
            $valor_uni_bruto = '0';
            if (isset($request['valor_uni_bruto']) && is_numeric($request['valor_uni_bruto'])) {
                $valor_uni_bruto = $request['valor_uni_bruto'];
            } else {
                $error = true;
                $errorVar .= "-valor_uni_bruto";
            }
            $valor_uni_iva = '0';
            if (isset($request['valor_uni_iva']) && is_numeric($request['valor_uni_iva'])) {
                $valor_uni_iva = $request['valor_uni_iva'];
            } else {
                $error = true;
                $errorVar .= "-valor_uni_iva";
            }
            $valor_uni_total = '0';
            if (isset($request['valor_uni_total']) && is_numeric($request['valor_uni_total'])) {
                $valor_uni_total = $request['valor_uni_total'];
            } else {
                $error = true;
                $errorVar .= "-valor_uni_total";
            }
            $referencia = '';
            if (isset($request['referencia'])) {
                $referencia = $request['referencia'];
            }


            /*
             * CA_FACTURA_PAGO
              ID_TS_PC_FP
              VALOR
              ID_BN
              ID_CB
              OFICINA
              NUM_DOC
              FECHA_DOC
             */
            $id_ts_pc_fp = 'null';
            if (isset($request['id_ts_pc_fp'])) {
                $id_ts_pc_fp = $request['id_ts_pc_fp'];
            } else {
                $error = true;
                $errorVar .= "-id_ts_pc_fp";
            }
            $valor = 'null';
            if (isset($request['valor'])) {
                $valor = $request['valor'];
            } else {
                $error = true;
                $errorVar .= "-valor";
            }
            $id_bn = 'null';
            if (isset($request['id_bn'])) {
                $id_bn = $request['id_bn'];
            } else {
                $error = true;
                $errorVar .= "-id_bn";
            }
            $id_cb = 'null';
            if (isset($request['id_cb'])) {
                $id_cb = $request['id_cb'];
            } else {
                $error = true;
                $errorVar .= "-id_cb";
            }
            $oficina = 'VENTAS PORTAL WEB';
            if (isset($request['oficina'])) {
                $oficina = $request['oficina'];
            }
            $num_doc_sop = '';
            if (isset($request['num_doc_sop'])) {
                $num_doc_sop = $request['num_doc_sop'];
            } else {
                $error = true;
                $errorVar .= "-num_doc_sop";
            }
            $fecha_doc_sop = '';
            if (isset($request['fecha_doc_sop'])) {
                $fecha_doc_sop = $request['fecha_doc_sop'];
            } else {
                $error = true;
                $errorVar .= "-fecha_doc_sop";
            }


            /**
             * validar parametros de entrada
             */
            if ($error) {
                /*
                 * Mensaje de error
                 */
                $mensajeError = "Los datos de entrada estan incorrectos." . " Variables :: " . $errorVar;

                $this->status = 1;
                $this->list_data = array();
                $this->mensajeError = $mensajeError;
                $this->logMessage("[FACTURA_PORTAL_ABACO] " . $mensajeError);
                $this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $mensajeError);

                $this->conn->commit();

                /*
                 * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
                 */
                $id_ope_bd = 3;
                $observacion = "'Se termino el proceso de factura_portal_abaco, se generaron errores en el proceso de creación.'";
                $this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $observacion . ".\n");



                /**
                 * Abrir nueva conexion con la Base de Datos
                 */
                $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
                $this->conn->beginTransaction();
                CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

                $error_log = $mensajeError . ". Correo de envio: " . $email;

                if ($this->parameters) {

                    $sql = <<<EOD
Insert into CA_LOG_FACTURA_ERRORES (ID_LOG_FACTURA_ERRORES,NUM_DOC,VALOR_TOTAL,ID_PRODUCTO,
    CANTIDAD,ID_TS_PC_FP,NUM_DOC_SOP,FECHA_DOC_SOP,
        FECHA_LOG,USUARIO_LOG,MOTIVO_ERROR) 
values (null,'$this->num_doc','$this->valor_total','$this->id_producto',
    '$this->cantidad','$this->id_ts_pc_fp','$this->num_doc_sop',to_date('$this->fecha_doc_sop', 'yyyy-mm-dd'),
        sysdate,'websafi','$error_log') 
EOD;

                    $records = CN_TABLE::executeSQL($sql, true);
                }

                $this->conn->commit();
            } else {

                /*
                 * Validar valor total de la factura
                 */
                if ($valor_total == $valor_uni_total) {


                    $this->logMessage("Validar valor total de la factura");

                    /**
                     * Validar num_doc_sop de la forma de pago
                     * Validar estado de la factura - 20170705
                     */
                    //sentencia sql
                    $sql = <<<EOD
select pag.* from ca_factura_pago pag
left join ca_factura_pos pos
on pos.id_factura = pag.id_factura
where 
pos.estado = 1
and pag.id_ts_pc_fp = $id_ts_pc_fp and pag.num_doc = '$num_doc_sop'   
EOD;
                    //ejecuta el sql
                    //$this->conn->execute($sql);
                    $resultado_fp = CN_TABLE::executeSQL($sql);

                    if (count($resultado_fp) <= 0) {


                        $this->logMessage("Validar num_doc_sop de la forma de pago");

                        /*
                         * CA_FACTURA_POS
                         */
                        //$id_punto_venta = 102;
                        //sentencia sql
                        $sql = <<<EOD
select * from ca_consecutivo_caja where id_punto_venta = $id_punto_venta   
EOD;
                        //ejecuta el sql
                        //$this->conn->execute($sql);
                        $resultado_punt = CN_TABLE::executeSQL($sql);

                        $id_caja = $resultado_punt[0]['id_caja'];
                        $consec_fac = $resultado_punt[0]['consec_fac'] + 1;
                        $sesion_caja = $resultado_punt[0]['sesion_caja'];

                        //Actualiza el consecutivo, este se vuelve a modificar al insertar la factura_pos - 20160223      
                        $sql = <<<EOD
update ca_consecutivo_caja set consec_fac = $consec_fac 
where id_punto_venta = $id_punto_venta and id_caja = $id_caja 
EOD;
                        //ejecuta el sql
                        $this->conn->execute($sql);

                        //sentencia sql
                        $sql = <<<EOD
select * from ca_estado_caja 
where id_punto_venta = $id_punto_venta and id_caja = $id_caja                                 
order by fecha_estado desc, sesion desc   
EOD;
                        //ejecuta el sql
                        //$this->conn->execute($sql);
                        $resultado_est = CN_TABLE::executeSQL($sql);

                        //verificar estado de la caja - 20150119
                        if (count($resultado_est) > 0 && $resultado_est[0]['estado'] == 1) {

                            $id_estado_caja = $resultado_est[0]['id_estado_caja'];
                            $cajero = $resultado_est[0]['cajero'];

                            //sentencia sql
                            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD HH24:MI:SS" 
EOD;

                            //ejecuta el sql
                            CN_TABLE::executeSQL($sql);


                            /*
                             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
                             */
                            $id_ope_bd = 3;
                            //construir observacion
                            $observacion = "'Se van a registrar detalles de la factura en CA_LOG_FACTURA'";
                            $this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $observacion . ".\n");
                            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

                            /**
                             * Se realiza registro de log de facturas exitosas - 20160527
                             */
                            $sql = <<<EOD
Insert into CA_LOG_FACTURA (ID_LOG_FACTURA,ID_PUNTO_VENTA,ID_CAJA,CONSEC_FAC,SESION_CAJA,
    ID_MAE_TER,FECHA_FACTURACION,VALOR_BRUTO,VALOR_IVA,VALOR_TOTAL,
        CAJERO,OBSERVACIONES,ID_PRODUCTO,CANTIDAD,VALOR_UNI_BRUTO,
            VALOR_UNI_IVA,VALOR_UNI_TOTAL,ID_TS_PC_FP,VALOR,ID_BN,ID_CB,
                NUM_DOC_SOP,FECHA_DOC_SOP,TERMINO_PROCESO,FECHA_LOG,USUARIO_LOG) 
values (null,'$id_punto_venta','$id_caja','$consec_fac','$sesion_caja',
    '$id_mae_ter',sysdate,'$valor_bruto','$valor_iva','$valor_total',
        '$cajero','$observaciones','$id_producto','$cantidad','$valor_uni_bruto',
            '$valor_uni_iva','$valor_uni_total','$id_ts_pc_fp','$valor',$id_bn,$id_cb,
                '$num_doc_sop',to_date('$fecha_doc_sop','yyyy-mm-dd'), 0, sysdate, 'websafi') 
EOD;
                            //ejecuta el sql
                            $result = CN_TABLE::executeSQL($sql);

                            //Ultimo registro insertado CA_LOG_FACTURA - 20160527
                            $sql = <<<EOD
select * from CA_LOG_FACTURA
where ID_LOG_FACTURA = (
    select
    max (ID_LOG_FACTURA)
    --ID_LOG_FACTURA
    from CA_LOG_FACTURA
    where
    id_punto_venta = $id_punto_venta
    and id_caja = $id_caja 
    and id_mae_ter = $id_mae_ter  
    and id_producto = $id_producto
)
and id_punto_venta = $id_punto_venta
and id_caja = $id_caja 
and id_mae_ter = $id_mae_ter
and id_producto = $id_producto 
                                    
order by
id_log_factura desc     
EOD;
                            //ejecuta y obtiene el resultado del sql
                            $resultado_log = CN_TABLE::executeSQL($sql);
                            if (count($resultado_log) > 0) {
                                $id_log_factura = $resultado_log[0]['id_log_factura'];
                            }


                            /*
                             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
                             */
                            $id_ope_bd = 3;
                            //construir observacion
                            $observacion = "'Registro de la factura en CA_FACTURA_POS, consec_fac::$consec_fac'";
                            $this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $observacion . ".\n");
                            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);


                            /**
                             * Incidente #3702 - 20160617
                             * Si la fecha de soporte no es en el mes de proceso, se coloca la fecha de proceso, sysdate,
                             * se coloca en las observaciones la fecha de soporte - 20160721
                             * Se cambia para que tome la fecha actual ya que en ABACO si quedan con el registro actual, y asi no tener diferencia ( and 1!=1 )- 200190829
                             */
                            //sentencia sql                
                            $sql = <<<EOD
Insert into CA_FACTURA_POS (ID_FACTURA,ID_ANHOS,ID_PUNTO_VENTA,ID_CAJA,SEC_FACTURA,ID_MAE_TER,
    FECHA_FACTURACION,VALOR_BRUTO,VALOR_IVA,VALOR_TOTAL,CAJERO,OBSERVACIONES,ESTADO,FECHA_ANU,MOTIVO_ANU,ID_ESTADO_CAJA,VALOR_RETEN,EMAIL_WEB) 
    values (null,to_char(sysdate,'yyyy'),$id_punto_venta,$id_caja,$consec_fac,$id_mae_ter,
        (select case when to_char(to_date('$fecha_doc_sop','yyyy-mm-dd'),'mm') = to_char(sysdate,'mm') 
            and to_char(to_date('$fecha_doc_sop','yyyy-mm-dd'),'yyyy') = to_char(sysdate,'yyyy') and 1!=1  
                then to_date('$fecha_doc_sop','yyyy-mm-dd') else sysdate end as fecha from dual),
            $valor_bruto,$valor_iva,$valor_total,$cajero,
                case when to_char(to_date('$fecha_doc_sop','yyyy-mm-dd'),'mm') = to_char(sysdate,'mm') 
            and to_char(to_date('$fecha_doc_sop','yyyy-mm-dd'),'yyyy') = to_char(sysdate,'yyyy') 
                then '$observaciones' else '$observaciones, Se reprocesa al mes actual de proceso fecha de soporte: $fecha_doc_sop' end ,1,null,null,$id_estado_caja,
                    0,'$email') 
EOD;
                            //ejecuta el sql
                            $this->conn->execute($sql);

                            //sentencia sql
                            /*
                             * Se adiciona filtro de sec_factura, 
                             * para traer el registro que corresponde a al factura ingresada anteriormente - 20160223
                             */
                            $sql = <<<EOD
select * from ca_factura_pos
where id_punto_venta = $id_punto_venta and id_caja = $id_caja 
    and id_mae_ter = $id_mae_ter and sec_factura = $consec_fac
order by fecha_facturacion desc    
EOD;
                            //ejecuta el sql
                            //$this->conn->execute($sql);
                            $resultado_facpos = CN_TABLE::executeSQL($sql);

                            $id_factura = $resultado_facpos[0]['id_factura'];



                            //sentencia sql
                            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;

                            //ejecuta el sql
                            CN_TABLE::executeSQL($sql);



                            /*
                             * CA_FACTURA_PROD
                             */
                            /*
                             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
                             */
                            $id_ope_bd = 3;
                            //construir observacion
                            $observacion = "'Registro del producto en CA_FACTURA_PROD, id_factura::$id_factura'";
                            $this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $observacion . ".\n");
                            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

                            //sentencia sql                
                            $sql = <<<EOD
Insert into CA_FACTURA_PROD (ID_FACTURA_PROD,ID_FACTURA,ID_PRODUCTO,CANTIDAD,VALOR_UNI_BRUTO,VALOR_UNI_IVA,VALOR_UNI_TOTAL,REFERENCIA) 
    values (null,$id_factura,$id_producto,$cantidad,$valor_uni_bruto,$valor_uni_iva,$valor_uni_total,'$referencia') 
EOD;
                            //ejecuta el sql
                            $this->conn->execute($sql);




                            /*
                             * CA_FACTURA_PAGO
                             */
                            /*
                             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
                             */
                            $id_ope_bd = 3;
                            //construir observacion
                            $observacion = "'Registro del pago en CA_FACTURA_PAGO, id_factura::$id_factura'";
                            $this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $observacion . ".\n");
                            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

                            /**
                             * Se agrega tipo de tramforma de pago en la oficina - 20160617
                             */
                            if ($id_ts_pc_fp == 21) {
                                $oficina = $oficina . ' - PSE';
                            } elseif ($id_ts_pc_fp == 22) {
                                $oficina = $oficina . ' - CODIGO BARRAS';
                            }

                            //sentencia sql                
                            $sql = <<<EOD
Insert into CA_FACTURA_PAGO (ID_FACTURA_PAGO,ID_FACTURA,ID_TS_PC_FP,VALOR,ID_BN,ID_CB,OFICINA,NUM_DOC,FECHA_DOC) 
    values (null,$id_factura,$id_ts_pc_fp,$valor,$id_bn,$id_cb,'$oficina','$num_doc_sop',to_date('$fecha_doc_sop','yyyy-mm-dd')) 
EOD;
                            //ejecuta el sql
                            $this->conn->execute($sql);



                            //Resultado para el Template
                            /**
                             * Datos de la factura, para devolver a la peticion del servicio - 20150206
                             */
                            //sentencia sql
                            $sql = <<<EOD
select tab0.*

from(

select 
tab1.*,
--tab3.encabezado, tab3.pie_pagina, 
tab3.descripcion as punto_venta,
tab2.sec_factura, tab2.fecha_facturacion, 
tab2.id_caja,tab2.cajero,
tab4.num_doc, tab4.razon_soc, 
tab7.direccion, tab7.tel, tab7.ciudad,
tab2.valor_bruto, tab2.valor_iva,tab2.valor_total, 
tab6.valor AS VALOR_CONSIGNADO,
tab6.oficina,
tab6.num_doc as num_doc_pago,
tab6.fecha_doc as fecha_doc_pago,
tab5.codigo as codigo_producto,
tab5.descripcion as descripcion_producto

from ca_factura_prod tab1
join ca_factura_pos tab2 ON tab1.id_factura = tab2.id_factura
join ca_punto_venta tab3 ON tab3.id_punto_venta = tab2.id_punto_venta
join interceros_v tab4 ON tab4.id_mae_ter = tab2.id_mae_ter
join ca_producto tab5 ON tab5.id_producto = tab1.id_producto
join(
    select 
    id_factura,
    wm_concat(oficina) as oficina,
    wm_concat(num_doc) as num_doc,
    wm_concat(fecha_doc) as fecha_doc,
    sum(nvl(valor,0)) as VALOR
    from ca_factura_pago
    group by id_factura
)tab6 ON tab6.id_factura = tab1.id_factura
join INTERCEROS_DU_DIR_V tab7 ON tab7.id_mae_ter = tab4.id_mae_ter

)tab0

where tab0.id_factura = $id_factura 
EOD;

                            //ejecuta el sql
                            $resultado = CN_TABLE::executeSQL($sql);
                            $record = array();
                            if (count($resultado) > 0) {
                                $record = $resultado;
                            }

                            $this->list_data = $record;
                            $this->logMessage("[FACTURA_PORTAL_ABACO] Genero registro.");
                            $this->custom_logger->info("[FACTURA_PORTAL_ABACO] Genero registro.");


                            $this->logMessage("[sfApiActions] Entro registro LOG.");
                            $this->custom_logger->info("[sfApiActions] Entro registro LOG.");
                            //$sql = CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter, $usuario, $comando, $observacion, $id_punto_venta_log);


                            /**
                             * Sentencia sql actualiza el log de factura, si termino
                             */
                            $sql = <<<EOD
update ca_log_factura set termino_proceso = 1 
where id_log_factura = $id_log_factura 
EOD;

                            $this->conn->execute($sql);

                            /**
                             * Incidente #10372, Generar registro detalle ABACO - 20181114
                             */
                            $sql = <<<EOD
Insert into CA_FACTURA_ABACO (ID_FACTURA,USUARIO,FECHA_LOG,IDINVOICE,MESSAGE,SUCCESSFUL_TXT,IDREQUEST,
    ESTADO_ABACO,FECHA_ABACO,ESTADO_CORREO,FECHA_CORREO) 
values ('$id_factura','websafi',sysdate,'$consec_fac',null,'false',null,
    '0',null,'0',null)
EOD;

                            $this->conn->execute($sql);


                            /*
                             * COMMIT DE TODAS LAS TRANSACCIONES
                             */
                            $this->conn->commit();


                            /**
                             * GENERAR MOVIMIENTO BANCO - 20150210
                             */
                            $this->logMessage("INICIO GENERAR MOVIMIENTO BANCO");
                            $this->custom_logger->info("INICIO GENERAR MOVIMIENTO BANCO");
                            /**
                             * Abrir nueva conexion con la Base de Datos
                             */
                            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
                            $this->conn->beginTransaction();

                            /*
                             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
                             */
                            $id_ope_bd = 3;
                            //construir observacion
                            $observacion = "'INICIO GENERAR MOVIMIENTO BANCO'";
                            $this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $observacion . ".\n");
                            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);


                            //Valida que aplica banco
                            //sentencia sql
                            $sql = <<<EOD
select * from ts_pc_fp
where id = $id_ts_pc_fp
and aplica_bn = 1 
EOD;

                            //ejecuta el sql
                            $resultado = CN_TABLE::executeSQL($sql);
                            $aplica_banco = false;
                            if (count($resultado) > 0) {
                                $aplica_banco = true;
                            }

                            if ($aplica_banco) {
                                $this->logMessage("GENERAR MOVIMIENTO BANCO");
                                $this->custom_logger->info("GENERAR MOVIMIENTO BANCO");

                                /*
                                 * Traer datos de la factura
                                 */
                                //sentencia sql
                                $sql = <<<EOD
select * from ca_factura_pos where  id_factura = $id_factura 
EOD;

                                //ejecuta el sql
                                $resultado = CN_TABLE::executeSQL($sql);
                                if (count($resultado) > 0) {
                                    $id_factura = $resultado[0]['id_factura'];
                                    $id_anhos = $resultado[0]['id_anhos'];
                                    $id_punto_venta = $resultado[0]['id_punto_venta'];
                                    $sec_factura = $resultado[0]['sec_factura'];
                                    $id_mae_ter = $resultado[0]['id_mae_ter'];
                                    $fecha_facturacion = $resultado[0]['fecha_facturacion'];
                                    $cajero = $resultado[0]['cajero'];
                                }

                                //Se trae de la configuracipon la url que se ha establecido para los mov banc
                                $arrayAtrib = array();

                                $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

                                $int = 0;
                                foreach ($array as $routeName => $routeData) {
                                    //echo $routeName . "\n";
                                    if ('service_url' == $routeName) {
                                        foreach ($routeData as $key => $value) {
                                            //echo $value . "\n";
                                            if ($key == 'value') {
                                                $service_url = $value;
                                            }
                                        }
                                    }
                                    $int++;
                                }
                                //$url = sfConfig::get('app-gwt_jasper_url');
                                //echo $url;
                                //$ch = curl_init("http://www.sofhouse.net/");
                                //&PARAM_comando=pos_imprimir_factura&PARAM_envio_correo=true&PARAM_mensaje_log=1");
                                $url = $service_url;
                                $url = $url . 'movimiento_banco_pos/list.json?PARAM_id_mod=12&PARAM_username=websafi&PARAM_nitocc=800189921&PARAM_id_username=946';


                                $url = $url . '&id_factura=' . $id_factura;
                                $url = $url . '&id_anhos=' . $id_anhos;
                                $url = $url . '&id_punto_venta=' . $id_punto_venta;
                                $url = $url . '&sec_factura=' . $sec_factura;
                                $url = $url . '&id_mae_ter=' . $id_mae_ter;
                                $url = $url . '&fecha_facturacion=' . $fecha_facturacion;
                                $url = $url . '&cajero=' . $cajero;
                                $url = $url . '&tag_portal_web=1'; //facturas portal web - validar el retorno del json - 20150210

                                $ch = curl_init($url);

                                //Parametros de retorno en cURL
                                curl_setopt($ch, CURLOPT_HEADER, 0);

                                //Ejecuta la petición
                                $rta = curl_exec($ch);
                                //Se cierra la conexión
                                curl_close($ch);

                                $arrayRespuesta = json_decode($rta, true);
                                //Verifica el status, si es diferente de 0, ocurrio un error al subir el mov banc y debe reportarlo
                                if ($arrayRespuesta['response']['status'] == 1) {
                                    $mensajeError = "Error :: Al generar el movimiento de bancos, se debe anular la factura.";
                                    $this->status = 1;
                                    $this->list_data = array();
                                    $this->mensajeError = $mensajeError;
                                    $this->logMessage("[FACTURA_PORTAL_ABACO] " . $mensajeError);
                                } else {
                                    $this->logMessage("[FACTURA_PORTAL_ABACO] Genero movimiento de bancos.");
                                }
                            } else {
                                $this->logMessage("[FACTURA_PORTAL_ABACO] No aplica bancos.");
                            }


                            /**
                             * FIN MOVBANC
                             */
                            /*
                             * COMMIT DE TODAS LAS TRANSACCIONES
                             */
                            $this->conn->commit();



                            /**
                             * Llamado INTERFAZ CONTABLE - 20190830
                             * Se coloca al final al hacer COMMIT de todo el debito y credito - 20170906
                             */
                            $this->logMessage("INICIO INTERFAZ CONTABLE FACTURA POS");

                            //Se trae de la configuracion la url que se ha establecido para las interfaces contables
                            $arrayAtrib = array();

                            $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

                            $int = 0;
                            foreach ($array as $routeName => $routeData) {
                                if ('service_url' == $routeName) {
                                    foreach ($routeData as $key => $value) {
                                        if ($key == 'value') {
                                            $service_url = $value;
                                        }
                                    }
                                }
                                $int++;
                            }
                            $url = $service_url;
                            $url = $url . 'ejecutaInterfacesContables/list.json?id_mod=11&username=websafi&nitocc=800189921&id_username=946';
                            //variables del debito
                            //$fecha_proceso = $fecha_sistema;
                            $id_mae_ter = 946;
                            $mov_ejecutado = "Factura-.-POS";
                            $url = $url . '&fecha_proceso=' . $fecha_proceso;
                            $url = $url . '&id_mae_ter=' . $id_mae_ter;
                            $url = $url . '&mov_ejecutado=' . $mov_ejecutado;
                            $url = $url . '&id_movimiento=' . $id_factura;
                            $url = $url . '&tag_portal_web=1'; //facturas portal web - validar el retorno del json

                            $ch = curl_init($url);

                            //Parametros de retorno en cURL
                            curl_setopt($ch, CURLOPT_HEADER, 0);
                            $rta = curl_exec($ch);
                            curl_close($ch);

                            $arrayRespuesta = json_decode($rta, true);
                            //Verifica el status, si es diferente de 0, ocurrio un error al subir la interfaz y debe reportarlo
                            if ($arrayRespuesta['response']['status'] == 1) {
                                $mensajeError = "Error :: Al generar la interfaz contable.";
                                $this->status = 1;
                                $this->list_data = array();
                                $this->mensajeError = $mensajeError;
                                $this->logMessage("[FACTURA_PORTAL_ABACO] " . $mensajeError);
                            } else {
                                $this->logMessage("[FACTURA_PORTAL_ABACO] Genero interfaz contable.");
                            }

                            $this->logMessage("FIN INTERFAZ CONTABLE FACTURA POS");



                            /**
                             * Incidente #10372, Llamado a servicio ABACO - 20181114
                             */
                            /*
                             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
                             */
                            $id_ope_bd = 3;
                            //construir observacion
                            $observacion = "'INICIO LLAMADO ABACO'";
                            $this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $observacion . ".\n");
                            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);


                            $array_abaco = $this->llamadoAbaco($id_factura);

                            $record[0]["message"] = $array_abaco["message"];
                            $record[0]["successful"] = $array_abaco["successful"];
                            $record[0]["idRequest"] = $array_abaco["idRequest"];

                            $this->list_data = $record;

                            $this->logMessage("[FACTURA_PORTAL_ABACO] Fin llamado a servicio ABACO.");
                        } else {

                            /*
                             * COMMIT DE TODAS LAS TRANSACCIONES
                             */
                            $this->conn->commit();

                            $mensaje = "Por favor verificar el estado de la caja, debe estar en estado cerrada.";

                            $this->logMessage($mensaje);
                            $this->custom_logger->info($mensaje);
                            $this->logMessage("state 1");

                            $this->status = 1;
                            $this->mensajeError = $mensaje;
                            $this->list_data = array(
                                array(
                                    'Code' => '1',
                                    'mensaje' => $mensaje
                                )
                            );

                            /*
                             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
                             */
                            $id_ope_bd = 3;
                            $observacion = "'Se termino el proceso de factura_portal_abaco, se generaron errores en el proceso de creación.'";
                            $this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $observacion . ".\n");



                            /**
                             * Abrir nueva conexion con la Base de Datos
                             */
                            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
                            $this->conn->beginTransaction();
                            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

                            $error_log = $mensaje . " Correo de envio: " . $email;

                            if ($this->parameters) {

                                $sql = <<<EOD
Insert into CA_LOG_FACTURA_ERRORES (ID_LOG_FACTURA_ERRORES,NUM_DOC,VALOR_TOTAL,ID_PRODUCTO,
    CANTIDAD,ID_TS_PC_FP,NUM_DOC_SOP,FECHA_DOC_SOP,
        FECHA_LOG,USUARIO_LOG,MOTIVO_ERROR) 
values (null,'$this->num_doc','$this->valor_total','$this->id_producto',
    '$this->cantidad','$this->id_ts_pc_fp','$this->num_doc_sop',to_date('$this->fecha_doc_sop', 'yyyy-mm-dd'),
        sysdate,'websafi','$error_log') 
EOD;

                                $records = CN_TABLE::executeSQL($sql, true);
                            }

                            $this->conn->commit();
                        }
                    } else {

                        /*
                         * COMMIT DE TODAS LAS TRANSACCIONES
                         */
                        $this->conn->commit();


                        /**
                         * Reprocesar el llamado a abaco, de ser invalido - 20190226
                         */
                        $id_factura = $resultado_fp[0]['id_factura'];
                        $array_abaco = $this->llamadoAbaco($id_factura);

                        $idinvoice_abaco = $array_abaco["idinvoice"];
                        $message_abaco = $array_abaco["message"];
                        $successful_abaco = $array_abaco["successful"];
                        $idRequest_abaco = $array_abaco["idRequest"];

                        if ($successful_abaco == 'false') {
                            $message_abaco = "Se intento reprocesar llamado a Abaco pero no hubo respuesta o genero el mensaje: " . $message_abaco . "";
                        }

                        $mensaje = "El numero $num_doc_sop del registro del pago, para la forma de pago seleccionada ya existe; favor verirficar.";

                        $this->logMessage($mensaje);
                        $this->custom_logger->info($mensaje);
                        $this->logMessage("state 1");

                        $this->status = 1;
                        $this->mensajeError = $mensaje;
                        $this->list_data = array(
                            array(
                                'Code' => '1',
                                'mensaje' => $mensaje,
                                'idinvoice_abaco' => $idinvoice_abaco,
                                'message_abaco' => $message_abaco,
                                'successful_abaco' => $successful_abaco,
                                'idRequest_abaco' => $idRequest_abaco
                            )
                        );

                        /*
                         * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
                         */
                        $id_ope_bd = 3;
                        $observacion = "'Se termino el proceso de factura_portal_abaco, se generaron errores en el proceso de creación.'";
                        $this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $observacion . ".\n");



                        /**
                         * Abrir nueva conexion con la Base de Datos
                         */
                        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
                        $this->conn->beginTransaction();
                        CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

                        $error_log = $mensaje . " Correo de envio: " . $email;

                        if ($this->parameters) {

                            $sql = <<<EOD
Insert into CA_LOG_FACTURA_ERRORES (ID_LOG_FACTURA_ERRORES,NUM_DOC,VALOR_TOTAL,ID_PRODUCTO,
    CANTIDAD,ID_TS_PC_FP,NUM_DOC_SOP,FECHA_DOC_SOP,
        FECHA_LOG,USUARIO_LOG,MOTIVO_ERROR) 
values (null,'$this->num_doc','$this->valor_total','$this->id_producto',
    '$this->cantidad','$this->id_ts_pc_fp','$this->num_doc_sop',to_date('$this->fecha_doc_sop', 'yyyy-mm-dd'),
        sysdate,'websafi','$error_log') 
EOD;

                            $records = CN_TABLE::executeSQL($sql, true);
                        }

                        $this->conn->commit();
                    }
                } else {

                    /*
                     * COMMIT DE TODAS LAS TRANSACCIONES
                     */
                    $this->conn->commit();

                    $mensaje = "EL valor de la factura no coincide con el total de los productos.";

                    $this->logMessage($mensaje);
                    $this->custom_logger->info($mensaje);
                    $this->logMessage("state 1");

                    $this->status = 1;
                    $this->mensajeError = $mensaje;
                    $this->list_data = array(
                        array(
                            'Code' => '1',
                            'mensaje' => $mensaje
                        )
                    );

                    /*
                     * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
                     */
                    $id_ope_bd = 3;
                    $observacion = "'Se termino el proceso de factura_portal_abaco, se generaron errores en el proceso de creación.'";
                    $this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $observacion . ".\n");



                    /**
                     * Abrir nueva conexion con la Base de Datos
                     */
                    $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
                    $this->conn->beginTransaction();
                    CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

                    $error_log = $mensaje . " Correo de envio: " . $email;

                    if ($this->parameters) {

                        $sql = <<<EOD
Insert into CA_LOG_FACTURA_ERRORES (ID_LOG_FACTURA_ERRORES,NUM_DOC,VALOR_TOTAL,ID_PRODUCTO,
    CANTIDAD,ID_TS_PC_FP,NUM_DOC_SOP,FECHA_DOC_SOP,
        FECHA_LOG,USUARIO_LOG,MOTIVO_ERROR) 
values (null,'$this->num_doc','$this->valor_total','$this->id_producto',
    '$this->cantidad','$this->id_ts_pc_fp','$this->num_doc_sop',to_date('$this->fecha_doc_sop', 'yyyy-mm-dd'),
        sysdate,'websafi','$error_log') 
EOD;

                        $records = CN_TABLE::executeSQL($sql, true);
                    }

                    $this->conn->commit();
                }
            }
        } catch (Exception $e) {

            //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
            $this->conn->rollback();

            $mensaje = "ERROR!!!";

            $this->logMessage($mensaje);
            $this->custom_logger->info("[FACTURA_PORTAL_ABACO] Exception:: " . $mensaje);
            $this->logMessage("state 2");
            $this->logMessage("Code " . $e->getCode());
            $this->logMessage("Message " . $e->getMessage());

            $this->status = 2;
            $this->mensajeError = $mensaje;
            $this->list_data = array(
                array(
                    'Code' => $e->getCode(),
                    'Message' => $e->getMessage(),
                    'Line' => $e->getLine(),
                    'Trace' => $e->getTraceAsString(),
                    'mensaje' => $mensaje
                )
            );

            /*
             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
             */
            $id_ope_bd = 3;
            $observacion = "'Se termino el proceso de factura_portal_abaco, se generaron errores en el proceso de creación...'";
            $this->custom_logger->info("[FACTURA_PORTAL_ABACO] Exception:: " . $observacion . ".\n");



            /**
             * Abrir nueva conexion con la Base de Datos
             */
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

            //Se cambian ' por chr(39), para no dañar el insert del log - 20160627
            $error_log = $mensaje . ' error message: ' . str_replace("'", "'|| chr(39) ||'", $e->getMessage()) . ' code: ' . $e->getCode() . ". Correo de envio: " . $email;

            if ($this->parameters) {

                $sql = <<<EOD
Insert into CA_LOG_FACTURA_ERRORES (ID_LOG_FACTURA_ERRORES,NUM_DOC,VALOR_TOTAL,ID_PRODUCTO,
    CANTIDAD,ID_TS_PC_FP,NUM_DOC_SOP,FECHA_DOC_SOP,
        FECHA_LOG,USUARIO_LOG,MOTIVO_ERROR) 
values (null,'$this->num_doc','$this->valor_total','$this->id_producto',
    '$this->cantidad','$this->id_ts_pc_fp','$this->num_doc_sop',to_date('$this->fecha_doc_sop', 'yyyy-mm-dd'),
        sysdate,'websafi','$error_log') 
EOD;

                $records = CN_TABLE::executeSQL($sql, true);
            }

            $this->conn->commit();
        }
    }

    /**
     * Se hace llamado a Abaco y se envia Email - 20181114
     * @param type $id_factura
     */
    public function llamadoAbaco($id_factura = null) {

        $id_factura_filtro = $id_factura;

        //Log especifico de procesos completos - 20160527
        $logPath = sfConfig::get('sf_log_dir') . '/factura_portal_abaco.log';
        $this->custom_logger = new sfFileLogger(new sfEventDispatcher(), array('file' => $logPath));

        $this->custom_logger->info("----------------------------------------BEGIN llamadoAbaco. id_factura::" . $id_factura);
        $this->logMessage("----------------------------------------BEGIN llamadoAbaco. id_factura::" . $id_factura);


        $id_tabla = $id_factura;
        $id_vigencia = 'null';
        $id_cen_op = 'null';
        $id_cia = 'null';

        //obtener id maestro tabla
        $id_mae_bd = CN_TABLE::consultarIdTablaBD('CA_FACTURA_ABACO');

        //  1- CONSULTAR, 2- ACTUALIZAR, 3 - ADICIONAR, 4 - ELIMINAR, 5 - ANULAR
        $id_ope_bd = 3;
        //id del maestro tercero
        $id_mae_ter_log = 1;
        $usuario = 'admin';
        $comando = 'factura_portal_abaco';
        //construir observacion
        $observacion = "'Se ingreso a generar llamadoAbaco.'";

        $id_punto_venta = '102';

        CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

        try {

            /**
             * Abrir nueva conexion con la Base de Datos
             */
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

            $int = 0;
            foreach ($array as $routeName => $routeData) {
                //echo $routeName . "\n";
                if ('url_abaco' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $url_abaco = $value;
                        }
                    }
                }
                if ('ipServidorCorreo' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $ipServidorCorreo = $value;
                        }
                    }
                }
                if ('correoEnvio' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $correoEnvio = $value;
                        }
                    }
                }
                $int++;
            }


            //valores por defecto
            $message = '';
            $successful = 'false';
            $idrequest = '';
            $idInvoice = '';

            if (!is_null($id_factura_filtro)) {

                $whereFactura = 'and tab0.id_factura = ' . $id_factura_filtro;
                $idInvoice = $id_factura_filtro;
            }

            /**
             * For de ca_facturas_abaco sin procesar para el estado_abaco en 0
             * Se coloca validación para cuando no tiene nombre o apellido - 20190618
             * Se valida en el nombre del tercero las comillas dobles - 20190628
             */
            $sql = <<<EOD
select
tab0.*,
pos.sec_factura,
pos.observaciones,
DECODE(ter.id_tip_ter, 1, 2, 2, 1) as id_tip_ter,
ter.num_doc,
DECODE(ter.id_tipo_doc, 1,13, 26,22, 27,11, 28,12, 29,31, 31,41, 81,31) as id_tipo_doc,
ter.dv,

upper(nvl(ter.direccion,'NA')) as direccion,
upper(ter.ciudad) as ciudad,
upper(nvl(dep.descripcion,11)) as departamento,
nvl(dep.coddepto,11) as coddepto,
upper( nvl(mun.codmun_text, nvl(mundep.codmun_text, case when dep.coddepto is null then '11001' else dep.coddepto||'001' end ) ) ) as codmun_text,
upper(replace(ter.razon_soc,'"','')) as razon_soc,
case when DECODE(ter.id_tip_ter, 1, 2, 2, 1) = 2 and ter.pnombre is null then upper(replace(ter.razon_soc,'"','')) else upper(replace(ter.pnombre,'"','')) end as pnombre,
upper(replace(ter.snombre,'"','')) as snombre,
case when DECODE(ter.id_tip_ter, 1, 2, 2, 1) = 2 and ter.papellido is null then upper(replace(ter.razon_soc,'"','')) else upper(replace(ter.papellido,'"','')) end as papellido,
ter.tel,
nvl( pos.email_web, nvl(ter.mail,ter.mail_con) ) as mail,

upper(produc.descripcion) as producto,
prod.valor_uni_bruto,
prod.valor_uni_total,

produc.codigo,
to_char(pos.fecha_facturacion,'dd/mm/yyyy') as fecha_facturacion,
upper(caj.prefijo || ' - ' || caj.ubicacion) as caja,
upper(bn.descripcion) as banco,
cb.numero_cuenta as cuenta,
upper(fp.descripcion) as tipo_pago,
upper(pag.oficina) as oficina,
pag.num_doc as pin,

pos.valor_total - pos.valor_iva as valorsiniva,
pos.valor_iva,
pos.valor_total,
upper(numero_a_texto(pos.valor_total)) as valor_total_text

from ca_factura_abaco tab0

left join ca_factura_pos pos
on pos.id_factura = tab0.id_factura

left join ca_caja caj
on caj.id_caja = pos.id_caja

left join ca_factura_prod prod
on pos.id_factura = prod.id_factura

left join ca_producto produc
on produc.id_producto = prod.id_producto

left join ca_factura_pago pag
on pos.id_factura = pag.id_factura

left join ts_pc_fp fp
on fp.id = pag.id_ts_pc_fp

left join ts_bn bn
on bn.id_bn = pag.id_bn

left join ts_cb cb
on cb.id_cb = pag.id_cb

left join interceros_du_dir_v ter
on ter.id_mae_ter = pos.id_mae_ter

left join departamento dep
on dep.coddepto = ter.copdepto

left join municipios mundep
on mundep.depto = dep.id_depto
and upper(mundep.municipio) = upper(ter.ciudad)

left join municipios mun
on mun.codmun = ter.codmun

where
tab0.estado_abaco = 0 
and tab0.id_factura is not null 
$whereFactura 

order by
tab0.fecha_log                 
EOD;

            //ejecuta el sql
            $resultado = CN_TABLE::executeSQL($sql);
            foreach ($resultado as $value) {

                $id_factura = $value['id_factura'];

                $this->custom_logger->info("Procesar el llamadoAbaco id_factura: " . $id_factura);
                $this->logMessage("Procesar el llamadoAbaco id_factura: " . $id_factura);

                $sec_factura = $value['sec_factura'];
                $observaciones = $value['observaciones'];
                $id_tip_ter = $value['id_tip_ter'];
                $num_doc = $value['num_doc'];
                $id_tipo_doc = $value['id_tipo_doc'];
                $dv = $value['dv'];
                $direccion = $value['direccion'];
                $direccion = str_replace('"', '', $direccion);
                $ciudad = $value['ciudad'];
                $departamento = $value['departamento'];
                $coddepto = $value['coddepto'];
                $codmun_text = $value['codmun_text'];
                $razon_soc = $value['razon_soc'];
                $pnombre = $value['pnombre'];
                $snombre = $value['snombre'];
                $papellido = $value['papellido'];
                $tel = $value['tel'];
                $mail = $value['mail'];

                $producto = $value['producto'];
                $valor_uni_bruto = $value['valor_uni_bruto'];
                $valor_uni_total = $value['valor_uni_total'];

                $codigo = $value['codigo'];
                $fecha_facturacion = $value['fecha_facturacion'];
                $caja = $value['caja'];
                $banco = $value['banco'];
                $cuenta = $value['cuenta'];
                $tipo_pago = $value['tipo_pago'];
                $oficina = $value['oficina'];
                $pin = $value['pin'];

                $valorsiniva = $value['valorsiniva'];
                $valor_iva = $value['valor_iva'];
                $valor_total = $value['valor_total'];
                $valor_total_text = $value['valor_total_text'];

                /** Ejemplo de JSON - ABACO
                  {
                  "username" : "adm_anm@yopmail.com",				//[Usuario del ANM previamente creado en la plataforma. Este usuario cambia de ambiente de producción a ambiente de pruebas]
                  "password" : "G+AiJ1Cq84iauVtdWTuhLk/xBGR0cC1rR3n0tScwWyM=",      //[Contraseña de acceso asociado al usuario - SHA256 codificada Base 64 de la contraseña registrada en la plataforma]
                  "objectType" :0,                                                  //[FACTURA(0), NOTA_CREDITO(1), NOTA_DEBITO(2)]
                  "invoiceIdType" :1,						//[FACTURA_DE_VENTA(0), FACTURA_DE_COMPRA_VENTA(1)]
                  "idRange" :174,							//[Identificador del rango de facturación registrado en la plataforma Ábaco. Esta información cambia de ambiente de pruebas a ambiente de producción]
                  "idObject" :"4",							//[Identificador de la Factura generado por la plataforma WebSafi]
                  "idInvoiceType" :120,						//[Identificador de la plantilla PDF a utilizar. Esta información cambia de ambiente de pruebas a ambiente de producción]
                  "idNoteType" : null,						//[Identificador de la plantilla PDF a utilizar para notas crédito. Esta información cambia de ambiente de pruebas a ambiente de producción]
                  "signed" : false,							//[true si se va a firmar digitalmente la factura]
                  "send" : false,							//[true si se va a enviar a la DIAN]
                  "sendToCustomer" : false,						//[true si se va a enviar al cliente]
                  "notificationStrings" : ["EMAIL"],				//[Mecanismo de envío de la factura al cliente]
                  "description" :"descripción de la factura",			//[Descripción de la factura]
                  "currencyCode" :"COP",						//[Código de moneda]
                  "customer" : {
                  "personType" :1,							//[PERSONA_JURIDICA(1), PERSONA_NATURAL(2), GRAN_CONTRIBUYENTE(3)]
                  "personId" :"890903937",						//[No. de documento]
                  "idType" :31,							//[NIT(31), REGISTRO_CIVIL(11), TARJETA_DE_IDENTIDAD(12), CEDULA_DE_CIUDADANIA(13), TARJETA_DE_EXTRANJERIA(21), CEDULA_DE_EXTRANJERIA(22), PASAPORTE(41), DOCUMENTO_DE_IDENTIFICACION_EXTRANJERO(42), NUIP(91)]
                  "schemeType" :0,							//[REGIMEN_SIMPLIFICADO(0), REGIMEN_OTRO(1), REGIMEN_COMUN(2),REGIMEN_CLIENTE_EN_EL_EXTERIOR(-1)]
                  "address" :"CALLE 12 7 46",					//[Dirección del adquirente]
                  "city" :"Bogotá, D.C.",						//[Ciudad del adquirente]
                  "department" :"BOGOTÁ DC",					//[Departamento del adquirente]
                  "citySubDivision" :"",						//[Barrio o zona del adquirente]
                  "countryCode" :"CO",						//[Código del país]
                  "organizationName" :"BANCO COLPATRIA S.A.",			//[Razón social o nombre del adquirente]
                  "firstName" :"",							//[Primer nombre]
                  "middleName" :"",							//[Segundo nombre]
                  "lastName" :"",							//[Apellido]
                  "codePhoneNumber" :"",						//[Código telefónico del país. i.e. +57]
                  "cellPhone" :"",							//[Número celular]
                  "email" :"diego.bulla@software-colombia.com"			//[Correo electrónico]
                  },
                  "lines" : [ {
                  "description" :"CERTIFICADO DE REGISTRO MINERO DIGITAL ",         //[Descripción del item facturado No. 1]
                  "quantity" : 1,							//[Cantidad del ítem facturado No. 1]
                  "currencyCode" :"COP",						//[Código de moneda]
                  "unityPrice" : 69000.00,						//[Precio unitario]
                  "noteLine" : null,						//[Observaciones]
                  "accountingCost" : null,						//[Centro de costo]
                  "totalPrice" : 69000.00,						//[Precio total]
                  "taxes" : [{
                  "taxAmount": 100000.0,						//[Base para el cálculo del impuesto]
                  "taxEvidenceType": false,                                         //[true: Impuesto retenido - false: Impuesto no retenido]
                  "taxableAmount": 19000.0,                                         //[Valor del impuesto]
                  "percent": 19.0,							//[Procentaje del impuesto]
                  "currencyCode": "COP",						//[Código de moneda]
                  "taxTypeCode": "01"						//[VALOR_TOTAL_DE_IVA("01"), VALOR_TOTAL_DE_IMPUESTO_AL_CONSUMO("02"), VALOR_TOTAL_DE_ICA("03"), VALOR_TOTAL_DE_IMPUESTO_NACIONAL_AL_CONSUMO("04")]
                  }] ,
                  },{
                  "description": "Esferos",
                  "quantity": 1,
                  "currencyCode": "COP",
                  "unityPrice": 120000.0,
                  "noteLine": null,
                  "accountingCost": null,
                  "totalPrice": 120000.0,
                  "taxes": []
                  }
                  ],
                  "extraWSProperties" : {
                  "Codigo" : "SM-40",                                               //[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  "Fecha" :"25/10/2018",						//[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  "Caja" :"01 - PRINCIPAL",						//[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  "Banco" :"BANCO DE BOGOTA",					//[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  "Cuenta" :"000021980",						//[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  "Recibo" :"CODIGO BARRAS",					//[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  "Oficina" :"VENTAS PORTAL WEB - CODIGO BARRAS",                   //[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  "Num" :"20180815093337"						//[Opcional: Nombre y valor de propiedades adicionales que no se enviarán a la DIAN pero sí se mostrarán en la factura]
                  },
                  "amountNoTaxes" :69000.00,					//[Total de la factura sin impuestos]
                  "amountTaxes" :13110.00,						//[Total de impuestos]
                  "totalAmount" :82110.00,						//[Total de la factura con impuestos]
                  "totalAmountText" :"DOSCIENTOS DIEZ MIL DOSCIENTOS SETENTA Y NUEVE PESOS CON DIEZ Y OCHO CENTAVOS M/CTE.************" //[Texto Total de la factura con impuestos]
                  }
                 */
                /**
                 * Paso Produccion - 20190215
                  "idRange" de 174 A   85
                  "idInvoiceType" de  120 A 121
                  "signed" :  false  A  true
                  "send": false  A  true
                  "sendToCustomer" :  false  A  true
                  "username": adm_anm@yopmail.com   A   factura.electronica@anm.gov.co
                 */
                /*
                 * Incidente #14878
                  "idRange" de 174 A 135
                 */
                /** Incidente #15151 - 20191129
                  "idObject": "SETT27", De esta manera se debe enviar en ambiente de pruebas las facturas, puedes utilizar desde número SETT28.
                  "idVerificationDigit": "1", En este campo se debe agregar el dígito de verificación de los Nit cliente.
                  "city": "15244", El código de la ciudad debe estar alineado a los códigos brindados y que te adjunto nuevamente.
                  "department" :"91", El código de la departamento debe estar alineado a los códigos brindados y que te adjunto nuevamente.
                 */
                //Parametros de app.yml - 20191129
                $username = sfConfig::get('app_username');
                $password = sfConfig::get('app_password');
                $idRange = sfConfig::get('app_idRange');
                $idInvoiceType = sfConfig::get('app_idInvoiceType');
                $signed = sfConfig::get('app_signed');
                $send = sfConfig::get('app_send');
                $sendToCustomer = sfConfig::get('app_sendToCustomer');
                $idObjectPrefijo = sfConfig::get('app_idObjectPrefijo');

                $json_clave = <<<EOD
{
	"username" : "$username",
	"password" : "$password",
EOD;
                $json_cuerpo = <<<EOD
	"objectType" :0,
	"invoiceIdType" :1,
	"idRange" :$idRange,
	"idObject" :"$idObjectPrefijo$sec_factura",
	"idInvoiceType" :$idInvoiceType,
	"idNoteType" : null,
	"signed" : $signed,
	"send" : $send,
	"sendToCustomer" : $sendToCustomer,
	"notificationStrings" : ["EMAIL"],
	"description" :"$observaciones",
	"currencyCode" :"COP",
	"customer" : {
		"personType" :$id_tip_ter,
		"personId" :"$num_doc",
		"idType" :$id_tipo_doc,
		"idVerificationDigit" :"$dv",
		"schemeType" :0,
		"address" :"$direccion",
		"city" :"$codmun_text",
		"department" :"$coddepto",
		"citySubDivision" :"",
		"countryCode" :"CO",
		"organizationName" :"$razon_soc",
		"firstName" :"$pnombre",
		"middleName" :"$snombre",
		"lastName" :"$papellido",
		"codePhoneNumber" :"",
		"cellPhone" :"$tel",
		"email" :"$mail"
	},
	"lines" : [ 
		{
		"description" :"$producto - $observaciones",
                "quantity" : 1,
		"currencyCode" :"COP",
		"unityPrice" : $valor_uni_bruto,
		"noteLine" : null,
		"accountingCost" : null,
		"totalPrice" : $valor_uni_total,
		"taxes" : []
		}
	],
	"extraWSProperties" : {
		"Codigo" : "$codigo",
		"Fecha" :"$fecha_facturacion",
		"Caja" :"$caja",
		"Banco" :"$banco",
		"Cuenta" :"$cuenta",
		"Recibo" :"$tipo_pago",
		"Oficina" :"$oficina",
		"Num" :"$pin"
	},
	"amountNoTaxes" :$valorsiniva,
	"amountTaxes" :$valor_iva,
	"totalAmount" :$valor_total,
	"totalAmountText" :"$valor_total_text M/CTE.************"
}
EOD;
                //Json de envio
                //Separa JSON por clave visible en log - 20191120
                $json = <<<EOD
$json_clave
$json_cuerpo                        
EOD;
                //echo $json;
                //die();
                $this->custom_logger->info("---Formato Json de envio:" . $json_cuerpo);
                $this->logMessage("---Formato Json de envio:" . $json_cuerpo);

                //Ejemplo Json simple
                //$data = array("name" => "Hagrid", "age" => "36");
                //$data_string = json_encode($data);
                $data_string = $json;

                /**
                 * Llamado CURL
                 */
                $ch = curl_init($url_abaco);
                //Parametros de retorno en cURL
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
                curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                    'Content-Type: application/json',
                    'Content-Length: ' . strlen($data_string))
                );
                //Ejecuta la petición
                $respuesta = curl_exec($ch);
                //$respuesta = "";
                $this->custom_logger->info("[FACTURA_PORTAL_ABACO] respuesta: " . $respuesta . ".\n");
                $this->logMessage("[FACTURA_PORTAL_ABACO] respuesta: " . $respuesta);
                //Error CURL
                if ($respuesta === false) {
                    $message = curl_error($ch);
                    //echo $message;
                } elseif (count($respuesta) <= 0) {
                    $this->logMessage("[FACTURA_PORTAL_ABACO] Sin respuesta.");
                    $message = "Sin respuesta.";
                }
                //Se cierra la conexión
                curl_close($ch);
                //die();
                //echo $respuesta;
                $arrayRespuesta = json_decode($respuesta, true);
                //print_r($arrayRespuesta);
                //die();
                //valida que esten las variables en la respuesta
                $this->logMessage("************Valida que esten las variables en la respuesta************");
                //if (isset($arrayRespuesta['idInvoice']) && isset($arrayRespuesta['message'])) {
                //if (true) {
                $pos = strpos($respuesta, 'idInvoice');
                $pos2 = strpos($respuesta, 'message');
                if ($pos !== false && $pos2 !== false) {

                    $this->logMessage("Si vienen variables en la respuesta de llamadoAbaco.");

                    $idInvoice = $arrayRespuesta['idInvoice'];
                    $message = $arrayRespuesta['message'];
                    $message = str_replace("'", "'|| chr(39) ||'", $message);
                    $successful = $arrayRespuesta['successful'];
                    if (isset($arrayRespuesta['idrequest'])) {
                        $idrequest = $arrayRespuesta['idrequest'];
                    } else {
                        $idrequest = '';
                    }

                    //valida successful
                    if ($successful == 'true') {
                        $successful = 'true';
                        $estado_abaco = '1';
                        $fecha_abaco = 'sysdate';
                    } else {
                        $successful = 'false';
                        $estado_abaco = '0';
                        $fecha_abaco = 'null';
                    }

                    //actualizar registro de CA_FACTURA_ABACO   
                    //set idinvoice = nvl('$idInvoice',idinvoice),se quida texto solo guarda numeros - 20191202 
                    $sql = <<<EOD
update CA_FACTURA_ABACO
set idinvoice = nvl(  translate( '$idInvoice','QWERTYUIOPASDFGHJKLÑZXCVBNMqwertyuiopasdfghjklñzxcvbnm','0')  ,idinvoice),
message = '$message',
successful_txt = '$successful',
idrequest = '$idrequest',
estado_abaco = '$estado_abaco',
fecha_abaco = $fecha_abaco
where
id_factura = $id_factura  
EOD;
                    //ejecuta el sql
                    $this->conn->execute($sql);
                } else {

                    $this->logMessage("No vienen variables en la respuesta de llamadoAbaco.");
                }
            }

            //die();
            /**
             * Incidente #10372, Llamado a servicio envio correo ABACO - 20181114
             */
            /*
             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
             */
            $id_ope_bd = 3;
            //construir observacion
            $observacion = "'INICIO LLAMADO ENVIO CORREO ABACO'";
            //$this->custom_logger->info("[FACTURA_PORTAL_ABACO] " . $observacion . ".\n");
            //CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);
            //$this->llamadoCorreoAbaco($id_factura);
            //$this->logMessage("[FACTURA_PORTAL_ABACO] Fin llamado a servicio envio correo ABACO.");


            $this->custom_logger->info("----------------------------------------FIN llamadoAbaco");
            $this->logMessage("----------------------------------------FIN llamadoAbaco");

            /*
             * COMMIT DE TODAS LAS TRANSACCIONES
             */
            $this->conn->commit();
            //die();

            $array_abaco = array(
                'message' => $message,
                'successful' => $successful,
                'idRequest' => $idrequest,
                'idinvoice' => $idInvoice
            );

            return $array_abaco;
        } catch (Exception $e) {

            //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
            $this->conn->rollback();

            $mensaje = "ERROR!!!";

            $this->logMessage($mensaje);
            $this->custom_logger->info("[FACTURA_PORTAL_ABACO] Exception:: " . $mensaje);
            $this->logMessage("state");
            $this->logMessage("Code " . $e->getCode());
            $this->logMessage("Message " . $e->getMessage());


            /*
             * Registro de consulta en tabla de log 1 - CONSULTAR, 2 - ACTUALIZAR, 3 - ADICIONAR, 4	- ELIMINAR, 5 - ANULAR
             */
            $id_ope_bd = 3;
            $observacion = "'Se termino el proceso de factura_portal_abaco llamadoAbaco, se generaron errores en el proceso de creación...'";
            $this->custom_logger->info("[FACTURA_PORTAL_ABACO] Exception:: " . $observacion . ".\n");

            /**
             * Abrir nueva conexion con la Base de Datos
             */
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            CN_TABLE::registroTableLog($id_tabla, $id_vigencia, $id_cen_op, $id_cia, $id_mae_bd, $id_ope_bd, $id_mae_ter_log, $usuario, $comando, $observacion, $id_punto_venta);

            $this->conn->commit();

            $this->custom_logger->info("----------------------------------------FIN Exception llamadoAbaco");
            $this->logMessage("----------------------------------------FIN Exception llamadoAbaco");


            $array_abaco = array(
                'message' => "Message " . $e->getMessage(),
                'successful' => 'false',
                'idRequest' => '',
                'idinvoice' => ''
            );

            return $array_abaco;
        }
    }

}
